<?php

class ProductAttributeModel {
  public $product_id = null;
  public $producttechattribute_id = null;
  public $value = null;

  public $create_by = null;
  public $edit_by = null;
  public $create = null;
  public $edit = null;
  

  public static function create(Array $data) {
    $model = new ProductAttribute();
    
    foreach($data as $field => $value) {
      if(property_exists(get_called_class(), $field)) {
        $model->$field = $value;
      }
    }
    
    $me = new User();
    $me->loadMe();

    if($model->create_by === null) {
      $model->create_by = $me->id;
    }
    if($model->edit_by === null) {
      $model->edit_by = $me->id;
    }
    
    return $model;
  }
  
  public static function getOne($id) {
    if(!is_numeric($id) || !$id) {
      throw new Exception("Invalid number", 400);
    }
    $item = [];
    $db = FronkDB::singleton();
    
    $res = $db->select("ProductAttribute", "*", "id=$id LIMIT 1");
    if($db->num_rows($res)) {
      $data = $db->fetch_object($res);
      $item = new ProductAttribute($data);
    }
    return $item;
  }
  
  public static function getAll() {
    $items = [];
    
    $db = FronkDB::singleton();
    
    $res = $db->select("ProductAttribute", "*", "1 = 1 ORDER BY product_id, producttechattribute_id");
    if($db->num_rows($res)) {
      while($data = $db->fetch_object($res)) {
        $items[$data->id] = new ProductAttribute($data);
      }
    }
    return $items;
    
  }
  
  public static function getFirst($filter) {
    $db = FronkDB::singleton();
    
    $where = self::getSqlFilter($filter);
    $res = $db->select("ProductAttribute", "*", "$where ORDER BY product_id, producttechattribute_id");
    if($db->num_rows($res)) {
      $data = $db->fetch_object($res);
      $item = new ProductAttribute($data);
      if($item->id) {
        return $item;
      } else {
        return null;
      }
    }
    return null;
  }
  
  public static function search($filter) {
    $items = [];
    $db = FronkDB::singleton();
    
    $where = self::getSqlFilter($filter);
    $res = $db->select("ProductAttribute", "*", "$where ORDER BY name");
    if($db->num_rows($res)) {
      while($data = $db->fetch_object($res)) {
        $items[$data->id] = new ProductAttribute($data);
      }
    }
    return $items;
  }
  
  private function getSqlFilter($filter) {
    $where = "1=1 ";
    
    $db = FronkDB::singleton();
    
    if(array_key_exists("product_id", $filter)) {
      $product_id = $filter['product_id'];
      if(is_numeric($product_id)) {
        $where .= " AND `product_id` = $product_id";
      }
    }
    
    if(array_key_exists("producttechattribute_id", $filter)) {
      $producttechattribute_id = $filter['producttechattribute_id'];
      if(is_numeric($producttechattribute_id)) {
        $where .= " AND `producttechattribute_id` = $producttechattribute_id";
      }
    }
    
    
    //var_dump($filter, $where);exit;
    return $where;
  }
  
}